
{         Copyright (c) 1987,88,90 by Borland International, Inc.          }

program CPASDEMO;
(*
  Dieses Programm zeigt die Schnittstelle zwischen Turbo Pascal und Turbo C.
  Mit Turbo C wird eine .OBJ-Datei (CPASDEMO.OBJ) erzeugt, die dann mit
  Hilfe der Compiler-Direktive {$L} in dieses Turbo Pascal-Programm
  eingebunden wird.

  ANMERKUNGEN:
    1. Das Turbo Pascal-Programm kann nicht auf Datendeklarationen des
       Turbo C-Moduls zugreifen. Die Daten mssen daher im Turbo Pascal-
       Programm deklariert werden.

    2. Wenn die C-Funktionen nur im Implementierungsbereich einer Unit
       verwendet werden, deklarieren Sie sie als NEAR. Wenn sie im Interface-
       bereich verwendet werden, deklarieren Sie sie als FAR. Kompilieren Sie
       die Turbo C-Module immer mit dem Speichermodell SMALL.

    3. Die Routinen der Turbo C Runtime-Bibliothek knnen nicht verwendet
       werden, da sie nicht die korrekten Segmentnamen besitzen. Wenn Sie
       aber die Quellen der Turbo C Runtime-Bibliothek besitzen (von Borland
       erhltlich), dann knnen Sie die Bibliotheksmodule rekompilieren und
       unter Pascal-Konventionen verwenden. Falls Sie rekompilieren, achten
       Sie darauf, da Sie fr alle Bibliotheksfunktionen, die Sie verwenden,
       Prototypen in Ihr C-Modul aufnehmen.

    4. Teile des von Turbo C generierten Codes sind Aufrufe interner Routinen.
       Diese knnen nicht verwendet werden, ohne da die entsprechenden Teile
       des Quellcodes der Turbo C Runtime-Bibliothek rekompiliert werden.

  Wenn Sie dieses Demonstrationsprogramm verwenden wollen, bentigen Sie
  folgende Dateien:

    TCC.EXE und CTOPAS.CFG
    oder
    TC.EXE und CTOPAS.TC

  Um das Demonstrationsprogramm CPASDEMO.EXE zu starten, fhren Sie folgende
  Schritte aus:

  1. Erzeugen Sie mit Turbo C eine mit Turbo Pascal 4.0 oder hher kompatible
     Datei CPASDEMO.OBJ.

    a) Wenn Sie Turbo C's integrierte Umgebung verwenden (TC.EXE), geben Sie
       am DOS-Prompt

       TC CTOPAS.PRJ
       
       ein. Mit ALT-F9 erzeugen Sie dann die .OBJ-Datei.

    b) Wenn Sie Turbo C's Kommandozeilen-Version verwenden (TCC.EXE), geben
       Sie am DOS-Prompt

       TCC +CTOPAS.CFG CPASDEMO.C

       ein. Beachten Sie: Die Konfigurationsdatei (CTOPAS.CFG oder CTOPAS.PRJ)
       mu die gleiche sein, wenn Sie Ihre eigenen Turbo C-Module, die unter
       Turbo Pascal laufen sollen, erzeugen.

  2. Kompilieren Sie das Turbo Pascal-Programm CPASDEMO.PAS, und fhren Sie
     es aus.

  Dieses einfache Programm ruft jede im Turbo C-Modul definierte Funktion
  auf. Jede der Turbo C-Funktionen ndert die aktuelle Bildschirmfarbe (durch
  Aufruf der Turbo Pascal-Prozedur SetColor. }
*)

uses Crt;

var
  Factor : Word;

{$L CPASDEMO.OBJ}  { das Turbo C-.OBJ-Modul einbinden }

function Sqr(I : Integer) : Word; external;
{ Die Farbe des Textes ndern und das Quadrat von I zurckgeben }

function HiBits(W : Word) : Word; external;
{ Die Farbe des Textes ndern und das hchstwertige Byte von W zurckgeben }

function Suc(B : Byte) : Byte; external;
{ Die Farbe des Textes ndern und B + 1 zurckgeben }

function Upr(C : Char) : Char; external;
{ Die Farbe des Textes ndern und den Grobuchstaben von C zurckgeben }

function Prd(S : ShortInt) : ShortInt; external;
{ Die Farbe des Textes ndern und S - 1 zurckgeben }

function LoBits(L : LongInt) : LongInt; external;
{ Die Farbe des Textes ndern und die untere Hlfte von L zurckgeben }

procedure StrUpr(var S : string); external;
{ Die Farbe des Textes ndern und S in Grobuchstaben zurckgeben - die }
{ Turbo C-Routine mu dazu das Lngenbyte des Strings berspringen. }

function BoolNot(B : Boolean) : Boolean; external;
{ Die Farbe des Textes ndern und NOT B zurckgeben }

function MultByFactor(W : Word) : Word; external;
{ Die Farbe des Textes ndern und W * Faktor zurckgeben - beachten Sie }
{ Turbo C's Zugriff auf Turbo Pascal's globale Variablen. }

procedure SetColor(NewColor : Byte); { Die Prozedur ndert die aktuellen    }
begin                                { Anzeigefarben, indem die CRT-Variable}
  TextAttr := NewColor;              { TextAttr gendert wird               }
end; { SetColor }

var
  S : string;

begin
  Writeln(Sqr(10));                  { Alle definierten Funktionen aufrufen }
  Writeln(HiBits(30000));            { und die passenden Infos bergeben    }
  Writeln(Suc(200));
  Writeln(Upr('x'));
  Writeln(Prd(-100));
  Writeln(LoBits(100000));
  S := 'abcdefg';
  StrUpr(S);
  Writeln(S);
  Writeln(BoolNot(False));
  Factor := 100;
  Writeln(MultbyFactor(10));
  SetColor(LightGray);
end.
