/* DCOPY.CPP -- Beispiel aus Kapitel 5 der Einfhrung */

/* DCOPY Quelldatei Zieldatei                          *
 * Kopiert eine existierende Quell- auf eine Zieldatei *
 * Wenn die Zieldatei existiert, wird sie berschrie-  *
 * ben, sonst wird sie von DCOPY erzeugt.              *
 */

#include <iostream.h>
#include <process.h>    // fr exit()
#include <fstream.h>    // fr ifstream, ofstream

main(int argc, char* argv[])  // Zugriff auf die Kommandozeilen-Argumente
{
   char ch;
   if (argc != 3)      // prft die Anzahl der Argumente
   {
      cerr << "GEBRAUCH: dcopy datei1 datei2\n";
      exit(-1);
   }

   ifstream source;    // deklariert den Ein-/Ausgabe-Strom
   ofstream dest;

   source.open(argv[1],ios::nocreate); // Quelldatei mu vorhanden sein
   if (!source)
   {
      cerr << "ffnen nicht mglich: Quelldatei " << argv[1] << "\n";
      exit(-1);
   }
   dest.open(argv[2]);   // Zieldatei erzeugen, wenn sie nicht vorhanden
			 // ist, oder sie wird berschrieben
   if (!dest)
   {
      cerr << "ffnen nicht mglich: Zieldatei " << argv[2] << "\n";
      exit(-1);
   }

   while (dest && source.get(ch)) dest.put(ch);

   cout << "DCOPY beendet\n";

   source.close();        // Ein- und Ausgabe-Strom schlieen
   dest.close();
}



