/* figures.h beschreibt drei Klassen:

  - Die Klasse Location bescheibt Orte auf
    dem Bildschirm mit X-Y-Koordinaten.

  - Die Klasse Point beschreibt, ob ein Punkt
    sichtbar ist oder nicht.

  - Die Klasse Circle beschreibt den Radius
    eines Kreises.

  Nehmen Sie #include <figures.h> in Ihr
  Hauptprogramm auf, wenn Sie dieses Modul
  verwenden wollen, und compilieren Sie
  FIGURES.CPP zusammen mit Ihrem Programm.
*/

enum Boolean {false, true};

class Location {
protected:
   int X;
   int Y;
public:
   Location(int InitX, int InitY)
   { X = InitX;
     Y = InitY;
   }
   int GetX() {return X;}
   int GetY() {return Y;}
};

class Point : public Location
{
protected:
   Boolean Visible;
public:
   Point(int InitX, int InitY);

   // Show und Hide sind virtuell
   virtual void Show();       
   virtual void Hide();

   // neue virtuelle Funktion Drag
   virtual void Drag(int DragBy); 
   Boolean IsVisible() {return Visible;}
   void MoveTo(int NewX, int NewY);
};

class Circle : public Point
{  // abgeleitet von der Klasse Point und
   //  der Klasse Location
protected:
   int Radius;
public:
   Circle(int InitX, int InitY, int InitRadius);
   void Show();
   void Hide();
   void Expand(int ExpandBy);
   void Contract(int ContractBy);
};

// Prototyp einer allgemeinen Nicht-Elementfunktion
// definiert in FIGURES.CPP

Boolean GetDelta(int& DeltaX, int& DeltaY);
