/* PLOTEMP3.C - Beispiel aus Kapitel 7 der
                Einfhrung */

/* Dieses Programm erzeugt eine Tabelle und ein
   Balkendiagramm aus einer Anzahl von
   Temperaturangaben */

#include <conio.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>

/* Prototypen */

void get_temps(void);
void table_view(void);
void min_max(void);
void avg_temp(void);
void graph_view(void);
void save_temps(void);
void read_temps(void);

/* Globale Definition */

#define TRUE      1
#define READINGS  8

/* Globale Datenstrukturen */

int temps[READINGS];

int main(void)
{
   char choice;

   while (TRUE)
   {
      printf("\nTemperaturen zeichen - "
             "Programm-Men\n");
      printf("\tE - Eingeben der Temperaturen\n");
      printf("\tS - Speichern der Daten auf der "
             "Platte\n");
      printf("\tL - Lesen der Daten von der Platte\n");
      printf("\tT - Tabelle der aktuellen Daten\n");
      printf("\tG - Grafik der aktuellen Daten\n");
      printf("\tX - Exit - das Programm beenden\n");
      printf("Drcken Sie eine der obigen Tasten: ");

      choice = toupper(getch());
      switch   (choice)
      {
         case 'E': get_temps();  break;
         case 'S': save_temps(); break;
	 case 'L': read_temps(); break;
         case 'T': table_view(); break;
         case 'G': graph_view(); break;
         case 'X': exit(0);
      }
   }
}

/* Funktionsdefinitionen */

void get_temps(void)
{
   char inbuf[130];
   int  reading;

   printf("\nGeben Sie die Temperaturen nacheinander "
          "ein.\n");
   for (reading = 0; reading < READINGS; reading++)
   {
      printf("\nTemperatur # %d eingeben: ",
             reading + 1);
      gets(inbuf);
      sscanf(inbuf, "%d", &temps[reading]);

      /* Zeigen, was gelesen worden ist */
      printf("\nGelesene Temperatur[%d] = %d",
             reading, temps[reading]);
   }
}

void table_view(void)
{
   int reading;

   clrscr();       /* lscht den Bildschirm */
   printf("Gelesen\t\tTemperaturen(C)\n");

   for (reading = 0; reading <= READINGS; reading++)
      printf("%d\t\t\t%d\n",
             reading + 1, temps[reading]);

   min_max();
   printf("Minimum-Temperatur: \n");
   printf("Maximum-Temperatur: \n");
   avg_temp();
   printf("Durchschnittstemperatur: \n");
}

void min_max(void)
{
   printf("\nAusfhren von min_max().\n");
}

void avg_temp(void)
{
   printf("\nAusfhren von avg_temp().\n");
}

void graph_view(void)
{
   printf("\nAusfhren von graph_view().\n");
}

void save_temps(void)
{
   printf("\nAusfhren von save_temps().\n");
}

void read_temps(void)
{
   printf("\nAusfhren von read_temps().\n");
}
