/* POINT2.CPP - Beispiel aus Kapitel 5 der
   Einfhrung */

// POINT2.CPP enthlt die Definitionen der
//  Klassen Point und Location,
//  die in der Datei point.h deklariert sind

#include "point.h"
#include <graphics.h>

// Elementfunktionen der Klasse Location
Location::Location(int InitX, int InitY)
{
   X = InitX;
   Y = InitY;
};

int Location::GetX(void)
{
   return X;
};

int Location::GetY(void)
{
   return Y;
};

// Elementfunktionen der Klasse Point:
//  Es wird angenommen, da das Hauptprogramm
//  das Grafik-System initialisiert hat

Point::Point(int InitX, int InitY) :
       Location(InitX,InitY)

{
   Visible = false;   // unsichtbar voreingestellt
};

void Point::Show(void) {
   Visible = true;

   // voreingestellte Farben
   putpixel(X, Y, getcolor());
};

void Point::Hide(void)
{
   Visible = false;

   // mit der Hintergrundfarbe lschen
   putpixel(X, Y, getbkcolor()); 
};

Boolean Point::IsVisible(void)
{
   return Visible;
};

void Point::MoveTo(int NewX, int NewY)
{
   Hide();    // den aktuellen Punkt unsichtbar
	      // machen
   X = NewX;  // X-Y-Koordinaten auf den neuen
   Y = NewY;  // Punkt einstellen
   Show();    // Punkt an der neuen Position
	      // zeigen
};
