/* VPOINT.CPP - Beispiel aus Kapitel 5 der
   Einfhrung */

/* VPOINT.CPP enthlt die Definitionen der
   Klassen Point und Location, die in der
   Datei vpoint.h deklariert sind
*/

#include "vpoint.h"
#include <graphics.h>

// Elementfunktionen der Klasse Location
Location::Location(int InitX, int InitY)
{
   X = InitX;
   Y = InitY;
};

int Location::GetX(void)
{
   return X;
};

int Location::GetY(void) {
   return Y;
};

/* Elementfunktionen der Klasse Point:
   Es wird angenommen, da das Hauptprogramm
   das Grafik-System initialisiert hat.
*/

Point::Point(int InitX, int InitY)
       : Location(InitX,InitY)

{  // unsichtbar voreingestellt
   Visible = false;
};

void Point::Show(void)
{
   Visible = true;

   // voreingestellte Farben
   putpixel(X, Y, getcolor());       
};

void Point::Hide(void)
{
   Visible = false;

   // lscht mit der Hintergrundfarbe
   putpixel(X, Y, getbkcolor()); 
};

Boolean Point::IsVisible(void)
{
   return Visible;
};

void Point::MoveTo(int NewX, int NewY)
{
   Hide();   // macht den aktuellen Punkt
	     // unsichtbar
   X = NewX; // X-Y-Koordinaten die neue
   Y = NewY; // Position zuweisen
   Show();   // zeigt den Punkt an der neuen
	     // Position
};
