/* vpoint.h - Beispiel aus Kapitel 5 der
   Einfhrung */

/* Diese Version von point.h mit virtuellen
   Funktionen ist fr VCIRCLE.
   vpoint.h enthlt zwei Klassen:
   - die Klasse Location beschreibt
     Bildschirmpositionen in X-Y-Koordinaten
   - die Klasse Point beschreibt, ob ein Punkt
     sichtbar ist oder nicht
*/

enum Boolean {false, true};

class Location
{
// Erlaubt der abgeleiteten Klasse Zugriff
// auf private Daten
protected:
   int X;
   int Y;

// Auf diese Funktionen kann von auen
// zugegriffen werden
public:
   Location(int InitX, int InitY);
   int GetX();
   int GetY();
};

class Point : public Location
{  // von der Klasse Location abgeleitet
   // public-Ableitung bedeutet, da X und Y
   // in Point protected sind

// von Point abgeleitete Klassen bentigen
// Zugriff
protected:
   Boolean Visible;  

public:
   Point(int InitX, int InitY);   // Konstruktor
   virtual void Show();
   virtual void Hide();
   Boolean IsVisible();
   void MoveTo(int NewX, int NewY);
};
